"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (_ref) {
  var t = _ref.types;

  var visitor = {
    ForOfStatement: function ForOfStatement(path) {
      var scope = path.scope;
      var _path$node = path.node,
          left = _path$node.left,
          right = _path$node.right,
          body = _path$node.body;

      var iterator = scope.maybeGenerateMemoised(right, true);
      var i = scope.generateUidIdentifier("i");

      var item = t.memberExpression(iterator, i, true);
      var assignment = void 0;
      if (t.isVariableDeclaration(left)) {
        assignment = left;
        assignment.declarations[0].init = item;
      } else {
        assignment = t.expressionStatement(t.assignmentExpression("=", left, item));
      }
      path.get("body").unshiftContainer("body", assignment);

      path.replaceWith(t.forStatement(t.variableDeclaration("let", [t.variableDeclarator(i, t.numericLiteral(0)), t.variableDeclarator(iterator, right)]), t.binaryExpression("<", i, t.memberExpression(iterator, t.identifier("length"))), t.updateExpression("++", i), body));
    }
  };

  return { visitor: visitor };
};